#ifndef _DisplayWindow_h_     // prevent multiple includes
#define _DisplayWindow_h_

//#include <GL/glew.h>     //--Extension Library-->Always include this before  <gl.h>
#include "GL/glew.h"
#include <FL/Fl.h>
#include <FL/gl.h>
//#include <FL/glut.h>
#include <GL/glu.h>
#include <FL/Fl_Gl_Window.h>
#include "Camera.h"
#include <FL/fl_ask.h>

#include <stdio.h>
#include <stdlib.h>
#include "Application.h"


class DisplayWindow : public Fl_Gl_Window 
{
	#define DOF	5.0f


public:
	DisplayWindow(int x,int y,int w,int h,const char *l=0);
	void draw();
	void initialize();
	void SetMesh(XMeshLib::Mesh * inMesh);
	
	void ProcessDraw();
	void ProcessRendering();
	void RenderMesh();


	//check later...
	void InitGL();
	void InitCamera();
	void InitLighting();

	XMeshLib::Mesh * theMesh;

private:
	XMeshLib::Camera theCamera;
	float rotate_dist;							// How far the center of the trackball is from the camera
	float view_dist;							// How far the center of the world is from the camera

	// GL info
	const GLubyte *gl_version;					// OpenGL Version
	const GLubyte *gl_vendor;					// OpenGL Vendor
	const GLubyte *gl_renderer;					// OpenGL PDecompRenderer
	const GLubyte *gl_extensions;				// OpenGL Extensions
	const GLubyte *glu_extensions;				// GLU Extensions
	bool glInitialized;							// Indicating whether the GL is initialized

};

#endif


